//+----------------------------------------------------------------------------+
//|                                                               i-Equity.mq4 |
//|                                                       . aka KimIV |
//|                                                        http://www.kimiv.ru |
//|                                                                            |
//|  05.10.2006     .                          |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 YellowGreen
#property indicator_width1 1

//-------    -----------------------------------------
extern double Deposit     = 1000;                //  
extern string BegTrade    = "2004.01.01 00:00";  //   
extern string Type        = "buy;buy";           //   (buy;sell;)
extern string Lots        = "0.1;0.1";           //  
extern string Symb        = "EURUSD;USDCHF";     //  
extern bool   ShowComment = True;                //  
extern bool   AccountSwap = True;                //  

//-------   ----------------------------------------------------
double dBuf0[];

//-------    -------------------------------------
int    oty[];      // 
double olo[];      // 
string osy[];      // 


//+----------------------------------------------------------------------------+
//| Custom indicator initialization function                                   |
//+----------------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, dBuf0);
  SetIndexLabel (0, "Equity");
  SetIndexStyle (0, DRAW_LINE);

  ReadDeals();
}

//+----------------------------------------------------------------------------+
//| Custom indicator deinitialization function                                 |
//+----------------------------------------------------------------------------+
void deinit() {
  Comment("");
}

//+----------------------------------------------------------------------------+
//| Custom indicator iteration function                                        |
//+----------------------------------------------------------------------------+
void start() {
  double e, p, pr, s, ss, v;
  double min=Deposit, max;
  int    i, j, k, nb, prevDay;

  nb=iBarShift(NULL, 0, StrToTime(BegTrade));
 	k=ArraySize(oty);

  for (i=Bars; i>=nb; i--) {
    dBuf0[i]=EMPTY_VALUE;
  }
  for (i=nb; i>=0; i--) {
    e=Deposit;
    for (j=0; j<k; j++) {
      p=MarketInfo(osy[j], MODE_POINT);
      v=MarketInfo(osy[j], MODE_TICKVALUE);
      if (oty[j]==OP_BUY) {
        s=MarketInfo(osy[j], MODE_SWAPLONG);
        e+=(iClose(osy[j],0,i)-iOpen(osy[j],0,nb))/p*v*olo[j];
      } else {
        s=MarketInfo(osy[j], MODE_SWAPSHORT);
        e+=(iOpen(osy[j],0,nb)-iClose(osy[j],0,i))/p*v*olo[j];
      }
      if (AccountSwap) {
        if (prevDay!=TimeDay(Time[i])) {
          ss+=s*olo[j];
          if (TimeDayOfWeek(Time[i])==3) ss+=2*s*olo[j];
          e+=ss;
        }
      }
    }
    prevDay=TimeDay(Time[i]);
    if (min>e) min=e;
    if (max<e) max=e;
    if (max-e>pr) pr=max-e;
    dBuf0[i]=e;
  }
  if (ShowComment) Comment("Min=",DoubleToStr(min,0),
                         "  Max=",DoubleToStr(max,0),
                         "  Range=",DoubleToStr(max-min,0),
                         "  DD=",DoubleToStr(pr,0)
                         );
}

//+----------------------------------------------------------------------------+
//|                                                                |
//+----------------------------------------------------------------------------+
void ReadDeals() {
  ReadTypes();
  ReadLots();
  ReadSymbol();
}

//+----------------------------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------------------------+
void ReadTypes() {
  int    i=0, np;
  string st, tmp=Type;
  ArrayResize(oty, 0);

  while (StringLen(tmp)>0) {
    np=StringFind(tmp, ";");
    if (np<0) {
      st=tmp;
      tmp="";
    } else {
      st=StringSubstr(tmp, 0, np);
      tmp=StringSubstr(tmp, np+1);
    }
    i++;
    ArrayResize(oty, i);
    if (st=="buy") oty[i-1]=0; else oty[i-1]=1;
  }
}

//+----------------------------------------------------------------------------+
//|                                                                 |
//+----------------------------------------------------------------------------+
void ReadLots() {
  int    i=0, np;
  string st, tmp=Lots;
  ArrayResize(olo, 0);

  while (StringLen(tmp)>0) {
    np=StringFind(tmp, ";");
    if (np<0) {
      st=tmp;
      tmp="";
    } else {
      st=StringSubstr(tmp, 0, np);
      tmp=StringSubstr(tmp, np+1);
    }
    i++;
    ArrayResize(olo, i);
    olo[i-1]=StrToDouble(st);
  }
}

//+----------------------------------------------------------------------------+
//|                                                              |
//+----------------------------------------------------------------------------+
void ReadSymbol() {
  int    i=0, np;
  string st, tmp=Symb;
  ArrayResize(osy, 0);

  while (StringLen(tmp)>0) {
    np=StringFind(tmp, ";");
    if (np<0) {
      st=tmp;
      tmp="";
    } else {
      st=StringSubstr(tmp, 0, np);
      tmp=StringSubstr(tmp, np+1);
    }
    i++;
    ArrayResize(osy, i);
    osy[i-1]=st;
  }
}
//+----------------------------------------------------------------------------+

